#include <iostream.h>
#include <math.h>

const double Pi = 3.14159;

class Figura
{
protected:
	double Pole;
	double Obwod;
public:
	virtual double OblPole() = 0;
	virtual double OblObwod() = 0;
	virtual void PunktyCharakterystyczne() = 0;
	virtual void Wczytaj() = 0;
};

class Wielokat : public Figura
{
protected:
	int LiczbaWierzcholkow;
public:
	virtual void PunktyCharakterystyczne()
	{
		cout << " liczba wierzcholkow :  " << LiczbaWierzcholkow << endl;
	}
};

class Elipsoida : public Figura
{
protected:
	int LiczbaOgnisk;
public:
	virtual void PunktyCharakterystyczne()
	{
		cout << " liczba ognisk : " << LiczbaOgnisk ;
	}

};

class Czworokat : public Wielokat
{
public:
	Czworokat()
	{
		LiczbaWierzcholkow = 4;
	}
};

class Prostokat : public Czworokat
{
	double BokA, BokB;
public:
	
	virtual double OblPole()
	{
		return BokA * BokB;
	}

	virtual double OblObwod()
	{
		return 2 * (BokA + BokB);
	}
	virtual void PunktyCharakterystyczne()
	{
		cout << endl << "Prostokat : ";
		Wielokat::PunktyCharakterystyczne();
	}

	virtual void Wczytaj()
	{
		cout << endl << "Podaj bok A : ";
		cin >> BokA;
		cout << endl << "Podaj bok B : ";
		cin >> BokB;
	}

};




class Kwadrat : public Czworokat
{
	double Bok;
public:
	virtual double OblPole()
	{
		return Bok * Bok;
	}

	virtual double OblObwod()
	{
		return 4 * Bok;
	}

	virtual void PunktyCharakterystyczne()
	{
		cout << endl << "Kwadrat : ";
		Wielokat::PunktyCharakterystyczne();
	}

	virtual void Wczytaj()
	{
		cout << endl << "Podaj bok A : ";
		cin >> Bok;
	}

};



class Trojkat : public Wielokat
{
	double BokA, BokB, BokC;
public:

	Trojkat()
	{
		LiczbaWierzcholkow = 3;
	}

	virtual double OblPole()
	{
		double p = 0.5 * OblObwod();
		return sqrt(p * (p - BokA) * (p - BokB) * (p - BokC));
	}

	virtual double OblObwod()
	{
		return BokA + BokB + BokC;
	}

	virtual void PunktyCharakterystyczne()
	{
		cout << endl << "Trojkat : ";
		Wielokat::PunktyCharakterystyczne();
	}

	virtual void Wczytaj()
	{
		cout << endl << "Podaj bok A : ";
		cin >> BokA;
		cout << endl << "Podaj bok B : ";
		cin >> BokB;
		cout << endl << "Podaj bok C : ";
		cin >> BokC;
	}

};




class Kolo : public Elipsoida
{
	double Promien;
public:
	Kolo()
	{
		LiczbaOgnisk = 1;
	}
	
	virtual double OblPole()
	{
		return Pi * Promien * Promien;
	}

	virtual double OblObwod()
	{
		return 2 * Pi * Promien;
	}

	virtual void PunktyCharakterystyczne()
	{
		cout << endl << "Kolo :";
		Elipsoida::PunktyCharakterystyczne();
	}

	virtual void Wczytaj()
	{
		cout << endl << "Podaj promien : ";
		cin >> Promien;
	}
};


class Elipsa : public Elipsoida
{
	double PromienA, PromienB;
public:
	Elipsa()
	{
		LiczbaOgnisk = 2;
	}
	
	virtual double OblPole()
	{
		return Pi * PromienA * PromienA;
	}

	virtual double OblObwod()
	{
		return Pi * (0.75 * (PromienA + PromienB) - sqrt(PromienA * PromienB));
	}

	virtual void PunktyCharakterystyczne()
	{
		cout << endl << "Elipsa : ";
		Elipsoida::PunktyCharakterystyczne();
	}

	virtual void Wczytaj()
	{
		cout << endl << "Podaj promien A : ";
		cin >> PromienA;
		cout << endl << "Podaj promien B : ";
		cin >> PromienB;
	}

};





void main()
{
	Figura *TaFi[100];


	char Polecenie;
	bool Jeszcze = true;
	int Pozycja = 0,  i;
	double S;

	while (Jeszcze)
	{
		cout << "\nPolecenie [F, P, O, C, Q] : ";
/*
	N - nowa figura
	P - suma pl wszystkich figur
	O - suma obwodow wszystkich figur 
	C - punkty charakterystyczne wszystkich figur
	Q - koniec programu
*/

		cin >> Polecenie;

		switch(Polecenie & 0x5F)
		{
		case 'F' : 
					if (Pozycja == 100)
					{
						cout <<"\nTablica pena.\n" ;
						break;
					}
					
					cout << endl << "Jaka figura : ";
					cout << endl << " 1 - Prostokat ";
					cout << endl << " 2 - Kwadrat ";
					cout << endl << " 3 - Trojkat ";
					cout << endl << " 4 - Kolo ";
					cout << endl << " 5 - Elipsa " << endl;

					cin >> i;

					switch (i)
					{
					case 1 : TaFi[Pozycja] = new Prostokat;
						      break;
					case 2 : TaFi[Pozycja] = new Kwadrat;
						      break;
					case 3 : TaFi[Pozycja] = new Trojkat;
						      break;
					case 4 : TaFi[Pozycja] = new Kolo;
						      break;
					case 5 : TaFi[Pozycja] = new Elipsa;
						      break;
					default : cout << " Zly wybor!" << endl;
								  break;

					}
					
					if (i < 1 || i > 5) break;

					TaFi[Pozycja++]->Wczytaj() ;

					break;
		case  'P' : 
					S = 0;
					for (i = 0; i < Pozycja; i++)
						S += TaFi[i]->OblPole();
					cout << "Suma pol wszystkich figur wynosi : " ;
					cout << S << endl;
					break;
		case 'O' : 
					S = 0;
					for (i = 0; i < Pozycja; i++)
						S += TaFi[i]->OblObwod();
					cout << "Suma obwodow wszystkich figur wynosi : " ;
					cout << S << endl;
					break;
		case 'C' : 
					for (i = 0; i < Pozycja; i++)
						TaFi[i]->PunktyCharakterystyczne();
					break;
		case 'Q' :	
					Jeszcze = false;
					break;
		default :
					cout << "\nBdne polecenie.\n";
		}
	}

}