//////////////   POMIARY   /////////////////

#include <iostream.h>
#include <fstream.h>
#include <math.h>
#include <string.h>


class Pomiary
{
	int LiczbaTablic;
	int LiczbaArytmetycznych;
public:
	ifstream PlikA, PlikB;
	ofstream PlikC;

	void Wykonaj();
	
	void OtwarciePlikow();
	void Przetwarzanie();
	void ZamknieciePlikow();

};

class BladSciezki
{
public:
	char Sciezka[32];

	BladSciezki(char* Bufor)
	{
		strncpy(Sciezka, Bufor, 31);
	}
};

void Pomiary::Wykonaj()
{
	LiczbaTablic = 0;
	LiczbaArytmetycznych = 0;

	
	try
	{
		OtwarciePlikow();
	}
	catch (int)
	{
		cout << endl << "Niepoprawna sciezka pliku. Koniec programu. ";
		cout << endl;
		return;
	}

	Przetwarzanie();

	ZamknieciePlikow();
	
	cout << endl << "Liczba przetworzonych tablic : " << LiczbaTablic;
	cout << endl << "Liczba srednich arytmetycznych : " << LiczbaArytmetycznych ;
	cout << endl;

}

void OtworzPlik(ifstream plik, char litera)
{
	char Bufor[32];

	cout << endl << "Podaj sciezke pliku : " << litera <<" :";
	cin >> Bufor;

		plik.open(Bufor, ios::in | ios::nocreate);

	if (plik.is_open() == 0)
			throw BladSciezki(Bufor);
		
}

void OtworzPlik(ofstream plik, char litera)
{
	char Bufor[32];

	cout << endl << "Podaj sciezke pliku : " << litera <<" :";
	cin >> Bufor;

	plik.open(Bufor, ios::out);

	if (plik.is_open() == 0)
			throw BladSciezki(Bufor);
		
}

void Pomiary::OtwarciePlikow()
{

	try
	{
		OtworzPlik(PlikA, 'A');
	}
	catch (BladSciezki Nazwa)
	{
		cout << endl << "Plik A : ";
		cout << Nazwa.Sciezka << " nie zostal odnaleziony.";
		throw 1;
	}

	try
	{
		OtworzPlik(PlikB, 'B');
	}
	catch (BladSciezki Nazwa)
	{
		cout << endl << "Plik B : ";
		cout << Nazwa.Sciezka << " nie zostal odnaleziony.";
		throw 1;
	}

	try
	{
		OtworzPlik(PlikC, 'C');
	}
	catch (BladSciezki Nazwa)
	{
		cout << endl << "Plik C : ";
		cout << Nazwa.Sciezka << "nie zostal utworzony.";
		throw 1;
	}

}


void Pomiary::ZamknieciePlikow()
{
	PlikA.close();
	PlikB.close();
	PlikC.close();
}


void SredniaC(double SA, double SB, double* SC)
{
	if (SA < 0 || SB < 0)
	{
		*SC = (SA + SB)/2.0;
		throw 1;
	}
	else
		*SC = sqrt(SA * SB);
}


void Pomiary::Przetwarzanie()
{

	double TabA[3], TabB[5];
	double SA, SB, SC;
	int i;

	while (!PlikA.eof() && !PlikB.eof())
	{
		SA = 0;
		for (i=0; i<3; i++)
		{
			PlikA >> TabA[i];
			SA += TabA[i];
		}
		SA /= 3;

		SB = 0;
		for (i=0; i<5; i++)
		{
			PlikB >> TabB[i];
			SB += TabB[i];
		}
		SB /= 5;

		try
		{
			SredniaC(SA, SB, &SC);
		}
		catch (int i)
		{
			LiczbaArytmetycznych += i;
		}

		LiczbaTablic++;

		PlikC << SC << endl;
	}
}


void main()
{
	Pomiary pomiary;
	pomiary.Wykonaj();
}



